﻿@inject Microsoft.AspNetCore.Http.IHttpContextAccessor HttpContextAccessor
@using TestYourSkills.Core.Enums
@using TestYourSkills.Web.Helpers
@model QuizProcessViewModel

@{
    ViewData["Title"] = "Completed Quiz";
}

<link rel="stylesheet" href="/css/topics/topic.css" xmlns="http://www.w3.org/1999/html"/>

<style>
          .linkPopup:active {
                  background:#2c3e50;
              }
              .linkPopup:before {
                  content:"Link Copied";
                  position:relative;
                  top:-15px;
                  background:#2c3e50;
                  border-radius:100px;
                  font-size:15px;      
                  color: whitesmoke;
                  display:none;
              }
              .linkPopup.active:before {
                  display:block;
              }
</style>

@{
    var percentages = (int)((double)Model.CorrectAnswersCount / @Model.Questions!.Count() * 100);
}

@{
    var currentUrl = UrlHelper.GetCurrentUrl(HttpContextAccessor);
}

<div class="d-flex justify-content-center py-4">
    @if (percentages < 40)
    {
        <h1>Oh... Don't be upset, study and repeat you'll be better 🥲</h1>
    }
    else if (percentages is >= 40 and < 75)
    {
        <h1>You're smart! but you'll need to study more 🫡</h1>
    }
    else
    {
        <h1>Wow You're so smart! Like a car😎</h1>
    }
</div>

<h4 class="text-center" style="position: relative;">
    <a id="copyLinkText" class="linkPopup" data-link-popup="linkPopup" href="@currentUrl" style="cursor: pointer;">Share quiz URL, it will be available for a while.</a>
</h4>

<h2>Count questions - [@Model.Questions!.Count()]</h2>
<h2>Correct answers - [@Model.CorrectAnswersCount]</h2>
<h2>Percentage correct answers - [@percentages%]</h2>

<div class="container py-4">
    @foreach (var question in Model.Questions!)
    {
        <div class="" style="border: 1px solid #2c3e50; padding: 10px; margin-bottom: 10px;">
            <h4 class="py-2 text-center">@question.Title</h4>

            @* <h4 class="col-12 fw-semibold" rows="3">question.Title</h4> *@

            @if (question.Details != null)
            {
                <textarea class="form-control py-3" rows="3">@question.Details</textarea>
            }

            <br/>

            @if (question.QuestionAnswers != null)
            {
                var userAnswer = Model.UserAnswers.FirstOrDefault(ua => ua.QuestionId == question.Id);

                foreach (var questionAnswer in question.QuestionAnswers)
                {
                    bool isChecked;
                    @if (userAnswer is {Ids: not null, ActionType: QuizActionType.GoNextQuestion }
                         && userAnswer.Ids.Contains(questionAnswer.Id))
                    {
                        isChecked = true;
                    }
                    else
                    {
                        isChecked = false;
                    }

                    <div class="row">
                        <fieldset class="form-group">
                            <div class="form-check 
                                @if (questionAnswer.CorrectAnswer) { @Html.Raw("text-bg-success") } 
                                else if (!questionAnswer.CorrectAnswer && isChecked) { @Html.Raw("text-bg-danger") }">
                                <label class="radio-button">
                                    @if (question.MultiAnswers)
                                    {
                                        <input type="checkbox" value="@questionAnswer.Id" disabled
                                               @if (isChecked)
                                               {
                                                   @Html.Raw("checked")
                                               }/>
                                    }
                                    else
                                    {
                                        <input type="radio" value="@questionAnswer.Id" disabled
                                               @if (isChecked)
                                               {
                                                   @Html.Raw("checked")
                                               }/>
                                    }
                                    <span class="checkmark"></span>
                                    @questionAnswer.Message
                                </label>
                            </div>
                        </fieldset>
                    </div>
                }

                @if (userAnswer is {ActionType: QuizActionType.DontKnow })
                {
                    <h4 class="text-danger text-center">Don't know!</h4>
                }
            }
        </div>
    }
</div>

<script>
      const linksContainer = document.getElementById("copyLinkText")
      linksContainer.addEventListener("click", copyToClipboard)
  
      function copyToClipboard(event){
          if (event.target.hasAttribute("data-link-popup")) {
                event.preventDefault()
                    const link = event.target.getAttribute("href")
  
                    event.target.classList.add("active");
                    navigator.clipboard.writeText(link)
                            setTimeout(function(){
                                event.target.classList.remove("active");
                            },2500);
          }
      }
</script>